%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  PHYS 210  Fall 2009
%
%  Term Project Component - Galaxy Merger Driver
%  
%  Generate galaxy merger with the following specification
%	- number of stars
%   - radius of the bulge
%	- radius of the disk
%   - inclination of the disk theta and phi in sphereical coordinates
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Turn off the paging of standard output so that messages appear 
% immediately on the screen instead of being buffered.
more off;

%  Enable(1)/Disable(0) the user prompt 
prompt = input('Custom input values?(0/1)');

%  Set output to 1 to store the data in a file.

%   Gm,  Gp,  Gv,  Gn,  Gr,  GR,  Gtheta,  Gphi,
%  GSm, GSp, GSv, GSn, GSr, GSR, GStheta, GSphi,
%   Sm,  Sp,  Sv,  Sn,  Sr,  SR,  Stheta,  Sphi,
%  tmax, level, soft, output
if prompt
[r tn T V E Gn GSn Sn] = Mmodel(
	Gm,  Gp,  Gv,  Gn,  Gr,  GR,  Gtheta, Gphi,
	GSm, GSp, GSv, GSn, GSr, GSR, GStheta, GSphi,
  	Sm, Sp, Sv, Sn, Sr, SR, Stheta, Sphi,  	
	tmax, level, soft, vert, out, fname)
else
[r tn T V E Gn GSn Sn] = Mmodel(
	5.8e+05, [-400  100 -300], [0 -10 0],  800, 3, 100, 2*pi/8, 1*pi/8,
	7.2e+05, [ 400 -200  300], [0  10 0], 1000, 4, 130, 5*pi/8, 3*pi/8,
	3.0e+03, [ 400  000  300], [60 10 0],    0, 0,  10, 0*pi/8, 2*pi/8,
	140, 10, 0.1, 1, 0);
endif


% convergence test
test=0;
if test

tmax = 200;
levelmin = 5;

Gnstar = 500;
Gtheta = 4*pi/8;
Gphi = 0*pi/8;
Ggpv = [0 0 0];

GSnstar = 500;
GStheta = 0*pi/8;
GSphi = 0*pi/8;
GSgpv = [0 0 0];

Snstar = 0;
Stheta = 4*pi/8;
Sphi = 0*pi/8;
Sgpv = [0 0 0];


Eplot=0;
if Eplot
[r tn T V E] = Mmodel(
			100, [-100   0  0], Ggpv, Gnstar, 3, 100, Gtheta, Gphi,
			100, [ 100   0  0], GSgpv, GSnstar, 3, 100, GStheta, GSphi,
			 10, [   0 100  0], Sgpv, Snstar, 0, 10, Stheta, Sphi,
			tmax, 7, 0.1);

clf;
hold on;
plot(tn, T, 'r');
plot(tn, V, 'g');
plot(tn, E, 'b');
xlabel('Time');
ylabel('Energy');
title('Energy V.S. Time');
legend('T', 'P', 'E','location','southeast');
fname = sprintf('E_galaxy_%d.ps',nstar);
print(fname, '-depsc');
input('Type ENTER to continue: ');
endif

clf;
hold on;
[r tn T V E] = Mmodel(
			100, [-100   0  0], Ggpv, Gnstar, 3, 100, Gtheta, Gphi,
			100, [ 100   0  0], GSgpv, GSnstar, 3, 100, GStheta, GSphi,
			 10, [   0 100  0], Sgpv, Snstar, 0, 10, Stheta, Sphi,
			tmax, levelmin, 0.1);

dE = E - E(1);
plot(tn, dE, 'b');
input('Type ENTER to continue: ');


[r tn T V E] = Mmodel(
			100, [-100   0  0], Ggpv, Gnstar, 3, 100, Gtheta, Gphi,
			100, [ 100   0  0], GSgpv, GSnstar, 3, 100, GStheta, GSphi,
			 10, [   0 100  0], Sgpv, Snstar, 0, 10, Stheta, Sphi,
			tmax, levelmin+1, 0.1);

dE = E - E(1);
plot(tn, dE, 'g');
input('Type ENTER to continue: ');


[r tn T V E] = Mmodel(
			100, [-100   0  0], Ggpv, Gnstar, 3, 100, Gtheta, Gphi,
			100, [ 100   0  0], GSgpv, GSnstar, 3, 100, GStheta, GSphi,
			 10, [   0 100  0], Sgpv, Snstar, 0, 10, Stheta, Sphi,
			tmax, levelmin+2, 0.1);

dE = E - E(1);
plot(tn, dE, 'r');
input('Type ENTER to continue: ');


[r tn T V E] = Mmodel(
			100, [-100   0  0], Ggpv, Gnstar, 3, 100, Gtheta, Gphi,
			100, [ 100   0  0], GSgpv, GSnstar, 3, 100, GStheta, GSphi,
			 10, [   0 100  0], Sgpv, Snstar, 0, 10, Stheta, Sphi,
			tmax, levelmin+3, 0.1);

dE = E - E(1);
plot(tn, dE, 'c');
input('Type ENTER to continue: ');

	
[r tn T V E] = Mmodel(
			100, [-100   0  0], Ggpv, Gnstar, 3, 100, Gtheta, Gphi,
			100, [ 100   0  0], GSgpv, GSnstar, 3, 100, GStheta, GSphi,
			 10, [   0 100  0], Sgpv, Snstar, 0, 10, Stheta, Sphi,
			tmax, levelmin+4, 0.1);

dE = E - E(1);
plot(tn, dE, 'm');
input('Type ENTER to continue: ');


[r tn T V E] = Mmodel(
			100, [-100   0  0], Ggpv, Gnstar, 3, 100, Gtheta, Gphi,
			100, [ 100   0  0], GSgpv, GSnstar, 3, 100, GStheta, GSphi,
			 10, [   0 100  0], Sgpv, Snstar, 0, 10, Stheta, Sphi,
			tmax, levelmin+5, 0.1);

dE = E - E(1);
plot(tn, dE, 'b');
input('Type ENTER to continue: ');


xlabel('Time');
ylabel('Energy');
title('Energy difference V.S. Time');
if levelmin == 4
legend('l4','l5','l6','l7','l8','l9','location','northeast');
elseif levelmin == 5
legend('l5','l6','l7','l8','l9','l10','location','northeast');
elseif levelmin == 6
legend('l6','l7','l8','l9','l10','l11','location','southeast');
elseif levelmin == 7
legend('l7','l8','l9','l10','l11','l12','location','southeast');
endif
fname = sprintf('%d_dE_galaxy_%d.ps',levelmin,Gnstar+GSnstar);
print(fname, '-depsc');
input('Done !! ');

endif




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  WARNING: The ploting below uses the plotting facility in octave. By 
%	    enabling the plotting, octave will plot all object in the
%	    system for every single time step. If your meachine is slow,
%	    I strongly recommand you to save the data to a file and 
%	    generate animations using xfpp3d.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


plot=0;

if plot
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do the plotting ...
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clf;
hold on;
% Create a title for the plot.
ptitle = sprintf('Galaxy');
title(ptitle);

% Plot the points from the Chaos Game as red dots.
xlabel('x');
ylabel('y');
zlabel('z');

Nt=length(r(1,1,:));
n=length(r(:,1,1));


%  plot the the entire simulation from t0 to tmax
anidsk=0;

if aniall
	gsn=1;
	sized=400;
	for t = [1:Nt]
		clf;
		hold on;
		plot3(r(gsn,1,t),r(gsn,2,t),r(gsn,3,t),'MarkerSize', 7, '+ro');
		plot3(r(gsn+1,1,t),r(gsn+1,2,t),r(gsn+1,3,t),'MarkerSize', 7, '+bo');
		plot3(r(gsn+2,1,t),r(gsn+2,2,t),r(gsn+2,3,t),'MarkerSize', 7, '+bo');
  		plot3(r(4:Gn+3,1,t),r(4:Gn+3,2,t),r(4:Gn+3,3,t),'+g');
  		plot3(r(Gn+4:Gn+GSn+3,1,t),r(Gn+4:Gn+GSn+3,2,t),r(Gn+4:Gn+GSn+3,3,t),'+c');
  		plot3(r(Gn+GSn+4:n,1,t),r(Gn+GSn+4:n,2,t),r(Gn+GSn+4:n,3,t),'+m');
  		axis([-sized sized -sized sized -sized sized]);
		xlabel('x');
		ylabel('y');
		zlabel('z');
		pause(0.05);
	endfor
	title('Moving Galaxy (1000 stars)');
	fname = sprintf('moveGalaxy.ps');
	print(fname, '-depsc');
endif



%  plot the time evolution of the bulges from t0 to tmax.
anibulge=0;

if anibulge
	sizeb=1000;
	for f = 1:Nt
		clf;
		hold on;
		axis([-sizeb sizeb -sizeb sizeb -sizeb sizeb]);
		plot3(r(1,1,f),r(1,2,f),r(1,3,f),'MarkerSize', 30, '*ro');
		plot3(r(2,1,f),r(2,2,f),r(2,3,f),'MarkerSize', 30, '*go');
		plot3(r(3,1,f),r(3,2,f),r(3,3,f),'MarkerSize', 5, '*bo');
		pause(0.01);
	endfor
endif


aniall=0;
if aniall
	sizea=3000;
	for m = 1:Nt
		clf;
		hold on;
		axis([-sizea sizea -sizea sizea -sizea sizea]);
		plot3(r(1,1,m),r(1,2,m),r(1,3,m),'MarkerSize', 30, '*ro');
		plot3(r(2,1,m),r(2,2,m),r(2,3,m),'MarkerSize', 30, '*go');
		plot3(r(3,1,m),r(3,2,m),r(3,3,m),'MarkerSize', 5, '*bo');
		plot3(r(4:nG+3,1,m),r(4:nG+3,2,m),r(4:nG+3,3,m),'+r');
		plot3(r(nG+4:nG+nGS+3,1,m),r(nG+4:nG+nGS+3,2,m),r(nG+4:nG+nGS+3,3,m),'+g');
		plot3(r(nG+nGS+4:nG+nGS+nS+3,1,m),r(nG+nGS+4:nG+nGS+nS+3,2,m),r(nG+nGS+4:nG+nGS+nS+3,3,m),'+b');
		pause(0.01);
	endfor
endif


% Create a file name for the Postscript file.
fname = sprintf('GMerger.ps');

% Generate the Postscript file.
print(fname,'-depsc');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ... end of plotting.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Pause execution by prompting the user for input.
%input('Type ''Enter'' to continue: ');

fprintf('\nDone!!\n\n');
endif
